<?php

    session_start();
    $admin_root = "..";
    $site_root = "../..";

    // ====== Load Functions Libraries ======

    require "$admin_root/repository/functions.php";
    require "$admin_root/repository/cms.php";
    require "$admin_root/repository/xml.php";
    $login = "$admin_root/login.php";
    require "$admin_root/modules/_security.php";

?>

<!doctype html>
<html lang='<?php echo $_SESSION["admin_lang"]; ?>'>
	<head>
		<meta charset="UTF-8">
		<title>X.able CMS / XML to JSON converter</title>
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="<?php echo "$admin_root/_tools/_tools.css" ?>" />
        <style></style>
    </head>
    <body>
        <button class='close' onclick="self.close()">X</button>
        
<?php
    
// ===================================================
//                      Sitemap
// ===================================================
    
    // ====== load XML data to array / begin ======
    function saveXmlJson($path) {
    // ----------------------------------------
    // $file = <string> File path
    // ----------------------------------------
    // RETURNS: <array> XML data converted to JSON
    // ----------------------------------------

        $xml = join(" ", array_map("trim", file($path)));
        $xml = xmlToArray($xml);
        if($xml) {
            if(array_shift(array_keys($xml)) == "xable") { $xml = $xml['xable'][0]; };
            //arrayList($xml);
            if($json = arrayToJson($xml)) {
            //if($json = json_encode($xml, true)) {

                $dir = path($path, "dirname");
                $file = path($path, "basename");
                $file = str_replace(".xml", ".json", $file);
                $new_path = "$dir/$file";
                echo "Saved: $path -> $new_path<br>\n";

                echo "<textarea style='width:100%;height:auto'>".$json."</textarea><br>\n";
                
                
                $xml_out = json_decode($json, true);
                if(is_array($xml_out)) {
                    echo "XML_ARRAY!<br>\n";
                }
                else {
                    echo "#ERROR!<br>\n";
                }
                //arrayList($xml_out);
            }
            else {
                "#ERROR! Conversion to JSON failed: $path<br>\n";
            }
        }
        else {
            echo "#ERROR! Not valid XML: $path<br>\n";
        }
        
        //return $xml;
    }; // ====== load XML data to array / end ======
        
    echo "<h1>1XML to JSON</h1><hr>\n";
    if(isset($_POST["action"]) && $_POST["action"] == "json") {
        $xable_ext = [ "draft", "prev", "xml", "order", "template" ];
        /*
        foreach(filesTree("$site_root/pages", ".") as $path) {
            $ext = path($path, "extension");
            if(in_array($ext, $xable_ext)) {
                $json = saveXmlJson($path);
            }
        }
        */
        
        foreach(listDir("$site_root", ".,?") as $path) {
            $ext = path($path, "extension");
            if(in_array($ext, $xable_ext) && path($path, "filename") != "browserconfig") {
                //echo "> $path<br>\n";
                $json = saveXmlJson($path);
            }
        }
    }
    else {
        echo "<form method='post'>\n";
        echo "<p>Convert all.</p>\n";
        echo "<button name='action' value='json' type='submit'>Submit</button>\n";
        echo "</form>\n";
    };

?> 
        
    </body>
</html>